scala.tools.nsc.symtab

# BrowsingLoaders

#### abstract class BrowsingLoaders extends GlobalSymbolLoaders

A subclass of SymbolLoaders that implements browsing behavior. This class should be used whenever file dependencies and recompile sets are managed automatically.

Source
  BrowsingLoaders.scala

Linear Supertypes
GlobalSymbolLoaders, SymbolLoaders, AnyRef, Any
Type Hierarchy Learn more about scaladoc diagrams
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. BrowsingLoaders
2. GlobalSymbolLoaders
3. SymbolLoaders
4. AnyRef
5. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show all

Learn more about member selection
Visibility

1. Public
2. All

### Instance Constructors

1. #### new BrowsingLoaders()

### Type Members

1. #### class ClassfileLoader extends SymbolLoader with (symbolTable)#FlagAssigningCompleter

   Definition Classes
     SymbolLoaders

2. #### class PackageLoader extends SymbolLoader with (symbolTable)#FlagAgnosticCompleter

   Load contents of a package

   Load contents of a package

   Definition Classes
     SymbolLoaders

3. #### class SourcefileLoader extends SymbolLoader with (symbolTable)#FlagAssigningCompleter

   Definition Classes
     SymbolLoaders

4. #### abstract class SymbolLoader extends (symbolTable)#SymLoader

   A lazy type that completes itself by calling parameter doComplete.

   A lazy type that completes itself by calling parameter doComplete. Any linked modules/classes or module classes are also initialized. Todo: consider factoring out behavior from TopClassCompleter/SymbolLoader into supertrait SymLoader

   Definition Classes
     SymbolLoaders

### Abstract Value Members

1. #### abstract val global: Global

   Definition Classes
     BrowsingLoaders → GlobalSymbolLoaders

2. #### abstract val platform: Global.platform

   Definition Classes
     GlobalSymbolLoaders → SymbolLoaders

### Concrete Value Members

1. #### final def !=(arg0: Any): Boolean

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Definition Classes
     AnyRef → Any

3. #### def +(other: String): String

   Implicit information
     This member is added by an implicit conversion from BrowsingLoaders to any2stringadd[BrowsingLoaders] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd

4. #### def ->[B](y: B): (BrowsingLoaders, B)

   Implicit information
     This member is added by an implicit conversion from BrowsingLoaders to ArrowAssoc[BrowsingLoaders] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()

5. #### final def ==(arg0: Any): Boolean

   Definition Classes
     AnyRef → Any

6. #### final def asInstanceOf[T0]: T0

   Definition Classes
     Any

7. #### def binaryOnly(owner: Global.Symbol, name: String): Boolean

   The package objects of scala and scala.reflect should always be loaded in binary if classfiles are available, even if sourcefiles are newer.

   The package objects of scala and scala.reflect should always be loaded in binary if classfiles are available, even if sourcefiles are newer. Late-compiling these objects from source leads to compilation order issues. Note: We do a name-base comparison here because the method is called before we even have ReflectPackage defined.

   Definition Classes
     SymbolLoaders

8. #### def browseTopLevel(root: Global.Symbol, src: AbstractFile): Unit

   Browse the top-level of given abstract file `src` and enter eny encountered top-level classes and modules in `root`

9. #### def clone(): AnyRef

   Attributes
     protected[java.lang]
   Definition Classes
     AnyRef
   Annotations
     @throws( ... )

10. #### def compileLate(srcfile: AbstractFile): Unit

    Should forward to `Run.compileLate`.

    Should forward to `Run.compileLate`. The more principled fix would be to determine why this functionality is needed and extract it into a separate interface.

    Attributes
      protected
    Definition Classes
      GlobalSymbolLoaders → SymbolLoaders

11. #### def ensuring(cond: (BrowsingLoaders) ⇒ Boolean, msg: ⇒ Any): BrowsingLoaders

    Implicit information
      This member is added by an implicit conversion from BrowsingLoaders to Ensuring[BrowsingLoaders] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

12. #### def ensuring(cond: (BrowsingLoaders) ⇒ Boolean): BrowsingLoaders

    Implicit information
      This member is added by an implicit conversion from BrowsingLoaders to Ensuring[BrowsingLoaders] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

13. #### def ensuring(cond: Boolean, msg: ⇒ Any): BrowsingLoaders

    Implicit information
      This member is added by an implicit conversion from BrowsingLoaders to Ensuring[BrowsingLoaders] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

14. #### def ensuring(cond: Boolean): BrowsingLoaders

    Implicit information
      This member is added by an implicit conversion from BrowsingLoaders to Ensuring[BrowsingLoaders] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

15. #### def enterClass(owner: Global.Symbol, name: String, completer: SymbolLoader): Global.Symbol

    Enter class with given `name` into scope of `root` and give them `completer` as type.

    Enter class with given `name` into scope of `root` and give them `completer` as type.

    Definition Classes
      SymbolLoaders

16. #### def enterClassAndModule(root: Global.Symbol, name: String, completer: SymbolLoader): Unit

    Enter class and module with given `name` into scope of `root` and give them `completer` as type.

    Enter class and module with given `name` into scope of `root` and give them `completer` as type.

    Definition Classes
      SymbolLoaders

17. #### def enterIfNew(owner: Global.Symbol, member: Global.Symbol, completer: SymbolLoader): Global.Symbol

    In browse mode, it can happen that an encountered symbol is already present.

    In browse mode, it can happen that an encountered symbol is already present. For instance, if the source file has a name different from the classes and objects it contains, the symbol loader will always reparse the source file. The symbols it encounters might already be loaded as class files. In this case we return the one which has a sourcefile (and the other has not), and issue an error if both have sourcefiles.

    Attributes
      protected
    Definition Classes
      BrowsingLoaders → SymbolLoaders

18. #### def enterModule(owner: Global.Symbol, name: String, completer: SymbolLoader): Global.Symbol

    Enter module with given `name` into scope of `root` and give them `completer` as type.

    Enter module with given `name` into scope of `root` and give them `completer` as type.

    Definition Classes
      SymbolLoaders

19. #### def enterPackage(root: Global.Symbol, name: String, completer: SymbolLoader): Global.Symbol

    Enter package with given `name` into scope of `root` and give them `completer` as type.

    Enter package with given `name` into scope of `root` and give them `completer` as type.

    Definition Classes
      SymbolLoaders

20. #### def enterToplevelsFromSource(root: Global.Symbol, name: String, src: AbstractFile): Unit

    Enter top-level symbols from a source file

    Enter top-level symbols from a source file

    Definition Classes
      BrowsingLoaders → SymbolLoaders

21. #### final def eq(arg0: AnyRef): Boolean

    Definition Classes
      AnyRef

22. #### def equals(arg0: Any): Boolean

    Definition Classes
      AnyRef → Any

23. #### def finalize(): Unit

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )

24. #### def formatted(fmtstr: String): String

    Implicit information
      This member is added by an implicit conversion from BrowsingLoaders to StringFormat[BrowsingLoaders] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()

25. #### final def getClass(): Class[_]

    Definition Classes
      AnyRef → Any

26. #### def hashCode(): Int

    Definition Classes
      AnyRef → Any

27. #### def initializeFromClassPath(owner: Global.Symbol, classRep: ClassRep): Unit

    Initialize toplevel class and module symbols in `owner` from class path representation `classRep`

    Initialize toplevel class and module symbols in `owner` from class path representation `classRep`

    Definition Classes
      SymbolLoaders

28. #### final def isInstanceOf[T0]: Boolean

    Definition Classes
      Any

29. #### def lookupMemberAtTyperPhaseIfPossible(sym: Global.Symbol, name: Global.Name): Global.Symbol

    Required by ClassfileParser.

    Required by ClassfileParser. Check documentation in that class for details.

    Definition Classes
      GlobalSymbolLoaders → SymbolLoaders

30. #### object moduleClassLoader extends SymbolLoader with (symbolTable)#FlagAssigningCompleter

    Definition Classes
      SymbolLoaders

31. #### final def ne(arg0: AnyRef): Boolean

    Definition Classes
      AnyRef

32. #### def newClassLoader(bin: AbstractFile): SymbolLoader

    Create a new loader from a binary classfile.

    Create a new loader from a binary classfile. This is intented as a hook allowing to support loading symbols from files other than .class files.

    Attributes
      protected
    Definition Classes
      SymbolLoaders

33. #### final def notify(): Unit

    Definition Classes
      AnyRef

34. #### final def notifyAll(): Unit

    Definition Classes
      AnyRef

35. #### var parentsLevel: Int

    used from classfile parser to avoid cyclies

    used from classfile parser to avoid cyclies

    Definition Classes
      SymbolLoaders

36. #### var pendingLoadActions: List[() ⇒ Unit]

    Definition Classes
      SymbolLoaders

37. #### def signalError(root: Global.Symbol, ex: Throwable): Unit

    Attributes
      protected
    Definition Classes
      SymbolLoaders

38. #### val symbolTable: global.type

    Definition Classes
      GlobalSymbolLoaders → SymbolLoaders

39. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

40. #### def toString(): String

    Definition Classes
      AnyRef → Any

41. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

42. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

43. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

44. #### def →[B](y: B): (BrowsingLoaders, B)

    Implicit information
      This member is added by an implicit conversion from BrowsingLoaders to ArrowAssoc[BrowsingLoaders] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Inherited from GlobalSymbolLoaders

### Inherited from SymbolLoaders

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from BrowsingLoaders to any2stringadd[BrowsingLoaders]

### Inherited by implicit conversion StringFormat from BrowsingLoaders to StringFormat[BrowsingLoaders]

### Inherited by implicit conversion Ensuring from BrowsingLoaders to Ensuring[BrowsingLoaders]

### Inherited by implicit conversion ArrowAssoc from BrowsingLoaders to ArrowAssoc[BrowsingLoaders]

### Ungrouped